AUI.Settings.Combat = {}

local DEFAULT_SCROLLING_TEXT_DAMAGE_OUT_NORMAL_COLOR = "#36a527"
local DEFAULT_SCROLLING_TEXT_DAMAGE_OUT_CRIT_COLOR = "#a01010"
local DEFAULT_SCROLLING_TEXT_DAMAGE_IN_NORMAL_COLOR = "#36a527"
local DEFAULT_SCROLLING_TEXT_DAMAGE_IN_CRIT_COLOR = "#a01010"
local DEFAULT_SCROLLING_TEXT_HEAL_OUT_NORMAL_COLOR = "#bda72b"
local DEFAULT_SCROLLING_TEXT_HEAL_OUT_CRIT_COLOR = "#b77102"
local DEFAULT_SCROLLING_TEXT_HEAL_IN_NORMAL_COLOR = "#bda72b"
local DEFAULT_SCROLLING_TEXT_HEAL_IN_CRIT_COLOR = "#b77102"
local DEFAULT_SCROLLING_TEXT_EXP_COLOR = "#3697db"
local DEFAULT_SCROLLING_TEXT_CXP_COLOR = "#31bfd9"
local DEFAULT_SCROLLING_TEXT_AP_COLOR = "#14aa34"
local DEFAULT_SCROLLING_TEXT_TELVAR_COLOR = "#6685a5"
local DEFAULT_SCROLLING_TEXT_COMBAT_START_COLOR = "#b80716"
local DEFAULT_SCROLLING_TEXT_COMBAT_END_COLOR = "#0cb82f"
local DEFAULT_SCROLLING_TEXT_INSTANT_CAST_COLOR = "#db7f1d"
local DEFAULT_SCROLLING_TEXT_ULTIMATE_READY_COLOR = "#e7e000"
local DEFAULT_SCROLLING_TEXT_POTION_READY_COLOR = "#08dc55"

local DEFAULT_DAMAGE_METER_FONT_COLOR = "#ffffff"

local isLoaded = false

local LAM = LibStub("LibAddonMenu-2.0")
local LMP = LibStub("LibMediaProvider-1.0")

local changed = false
local minimeter_enabled = false

local function GetDefaultSettings()
	local defaultSettings =
	{
		--minimeter
		minimeter_position = 
		{
			point = TOPLEFT,
			relativePoint = TOPLEFT,
			offsetX = 0,
			offsetY = 0
		},	
		minimeter_enabled = true,
		minimeter_show_background = false,
		minimeter_show_dps_out = true,
		minimeter_show_total_damage_out = true,
		minimeter_show_hps_out = false,
		minimeter_show_total_heal_out = false,
		minimeter_show_dps_in = false,
		minimeter_show_total_damage_in = false,
		minimeter_show_hps_in = false,
		minimeter_show_total_heal_in = false,		
		minimeter_show_combat_time = true,
		--combat statistics
		detail_statistic_window_position = 
		{
			point = CENTER,
			relativePoint = CENTER,
			offsetX = 0,
			offsetY = 0
		},	
		--scrolling text
		scrolling_text_enabled = true,
		
		scrolling_text_report_main_window_width = 200,
		scrolling_text_report_main_window_height = 500,	
		scrolling_text_report_duration = 3.3,
		scrolling_text_report_animation = AUI_ANIMATION_VERTICAL,			
		scrolling_text_report_animation_mode = AUI_ANIMATION_MODE_BACKWARD,	
		scrolling_text_assemble_exp = true,
		scrolling_text_assemble_cxp = true,
		scrolling_text_assemble_ap = true,
		scrolling_text_assemble_telvar = true,
		scrolling_text_show_exp = false,
		scrolling_text_show_cxp = true,
		scrolling_text_show_ap = true,
		scrolling_text_show_telvar = true,
		scrolling_text_show_combat_start = false,
		scrolling_text_show_combat_end = false,
		scrolling_text_show_instant_casts = true,
		scrolling_text_show_ultimate_ready = false,
		scrolling_text_show_potion_ready = false,
		scrolling_text_exp_size = 24,
		scrolling_text_cxp_size = 24,
		scrolling_text_ap_size = 24,
		scrolling_text_telvar_size = 24,
		scrolling_text_combat_start_size = 34,
		scrolling_text_combat_end_size = 34,
		scrolling_text_instant_cast_size = 34,
		scrolling_text_ultimate_ready_size = 34,
		scrolling_text_potion_ready_size = 34,
		scrolling_text_exp_color = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_EXP_COLOR, 1),
		scrolling_text_cxp_color = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_CXP_COLOR, 1),
		scrolling_text_ap_color = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_AP_COLOR, 1),
		scrolling_text_telvar_color = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_TELVAR_COLOR, 1),		
		scrolling_text_combat_start_color = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_COMBAT_START_COLOR, 1),
		scrolling_text_combat_end_color = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_COMBAT_END_COLOR, 1),	
		scrolling_text_instant_cast_color = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_INSTANT_CAST_COLOR, 1),	
		scrolling_text_ultimate_ready_color = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_ULTIMATE_READY_COLOR, 1),	
		scrolling_text_potion_ready_color = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_POTION_READY_COLOR, 1),	
		scrolling_text_exp_font_art = "Sansita One",
		scrolling_text_cxp_font_art = "Sansita One",
		scrolling_text_ap_font_art = "Sansita One",	
		scrolling_text_telvar_font_art = "Sansita One",	
		scrolling_text_combat_start_font_art = "Sansita One",	
		scrolling_text_combat_end_font_art = "Sansita One",
		scrolling_text_instant_cast_font_art = "Sansita One",		
		scrolling_text_ultimate_ready_font_art = "Sansita One",
		scrolling_text_potion_ready_font_art = "Sansita One",
			
		scrolling_text_assemble_damage_out_normal = true,
		scrolling_text_assemble_damage_out_crit = true,
		scrolling_text_assemble_heal_out_normal = true,		
		scrolling_text_assemble_heal_out_crit = true,	
		scrolling_text_show_damage_out = false,
		scrolling_text_show_critical_damage_out = true,
		scrolling_text_show_heal_out = false,
		scrolling_text_show_critical_heal_out = true,
		scrolling_text_out_damage_normal_size = 34,
		scrolling_text_out_damage_crit_size = 34,
		scrolling_text_out_heal_normal_size = 34,
		scrolling_text_out_heal_crit_size = 34,	
		
		scrolling_text_out_show_icons = true,
		scrolling_text_out_main_window_width = 200,
		scrolling_text_out_main_window_height = 1000,
		scrolling_text_out_duration = 3.0,
		scrolling_text_out_animation = AUI_ANIMATION_ECLIPSE,
		scrolling_text_out_animation_mode = AUI_ANIMATION_MODE_REVERSE_BACKWARD,	
		scrolling_text_damage_out_color_normal = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_DAMAGE_OUT_NORMAL_COLOR, 1),	
		scrolling_text_damage_out_color_crit = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_DAMAGE_OUT_CRIT_COLOR, 1),
		scrolling_text_heal_out_color_normal = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_HEAL_OUT_NORMAL_COLOR, 1),	
		scrolling_text_heal_out_color_crit = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_HEAL_OUT_CRIT_COLOR, 1),	
		scrolling_text_damage_out_normal_font_art = "Sansita One",
		scrolling_text_damage_out_crit_font_art = "Sansita One",
		scrolling_text_heal_out_normal_font_art = "Sansita One",
		scrolling_text_heal_out_crit_font_art = "Sansita One",	
		
		scrolling_text_assemble_damage_in_normal = true,	
		scrolling_text_assemble_damage_in_crit = true,
		scrolling_text_assemble_heal_in_normal = true,	
		scrolling_text_assemble_heal_in_crit = true,	
		scrolling_text_show_damage_in = false,
		scrolling_text_show_critical_damage_in = false,
		scrolling_text_show_heal_in = false,	
		scrolling_text_show_critical_heal_in = false,
		scrolling_text_in_assemble = true,
		scrolling_text_in_damage_normal_size = 34,
		scrolling_text_in_damage_crit_size = 34,
		scrolling_text_in_heal_normal_size = 34,
		scrolling_text_in_heal_crit_size = 34,	
		scrolling_text_in_show_icons = true,
		scrolling_text_in_main_window_width = 200,
		scrolling_text_in_main_window_height = 1000,
		scrolling_text_in_duration = 3.0,
		scrolling_text_in_animation = AUI_ANIMATION_ECLIPSE,
		scrolling_text_in_animation_mode = AUI_ANIMATION_MODE_BACKWARD,	
		scrolling_text_damage_in_color_normal = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_DAMAGE_IN_NORMAL_COLOR, 1),	
		scrolling_text_damage_in_color_crit = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_DAMAGE_IN_CRIT_COLOR, 1),		
		scrolling_text_heal_in_color_normal = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_HEAL_IN_NORMAL_COLOR, 1),	
		scrolling_text_heal_in_color_crit = AUI.Color.ConvertHexToRGBA(DEFAULT_SCROLLING_TEXT_HEAL_IN_CRIT_COLOR, 1),		
		scrolling_text_damage_in_normal_font_art = "Sansita One",	
		scrolling_text_damage_in_crit_font_art = "Sansita One",	
		scrolling_text_heal_in_normal_font_art = "Sansita One",
		scrolling_text_heal_in_crit_font_art = "Sansita One",			
		
		scrolling_text_report_position = 
		{
			point = CENTER,
			relativePoint = CENTER,
			offsetX = 0,
			offsetY = 0
		},
		scrolling_text_outgoing_position = 
		{
			point = LEFT,
			relativePoint = LEFT,
			offsetX = 500,
			offsetY = 0
		},
		scrolling_text_incomming_position = 
		{
			point = RIGHT,
			relativePoint = RIGHT,
			offsetX = -600,
			offsetY = 0
		},	

		--damage meter
		damage_meter_enabled = false,
		damage_meter_show_background = true,
		damage_meter_damage_mode = AUI_COMBAT_DATA_TYPE_DAMAGE_OUT,
		damage_meter_font_art = "Univers 55",
		damage_meter_font_size = 13,
		damage_meter_font_color = AUI.Color.ConvertHexToRGBA(DEFAULT_DAMAGE_METER_FONT_COLOR, 1),
		damage_meter_show_only_in_group = true,
		damage_meter_position = 
		{
			point = TOPRIGHT,
			relativePoint = TOPRIGHT,
			offsetX = 0,
			offsetY = 330
		},		
	}

	return defaultSettings
end

local function AcceptSettings()
	AUI.Settings.Combat.minimeter_enabled = minimeter_enabled
	AUI.Settings.Combat.scrolling_text_enabled = scrolling_text_enabled
	AUI.Settings.Combat.damage_meter_enabled = damage_meter_enabled
	
	ReloadUI()
end

local function GetMinimeterOptions()
	local optionsTable = {	
		{		
			type = "submenu",
			name = AUI_TXT_COLOR_SUBMENU:Colorize(AUI.L10n.GetString("minimeter")),
			controls = 
			{		
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_background"),
					getFunc = function() return AUI.Settings.Combat.minimeter_show_background end,
					setFunc = function(value)
						AUI.Settings.Combat.minimeter_show_background = value
						AUI.Combat.Minimeter.UpdateUI()
					end,
					default = GetDefaultSettings().minimeter_show_background,
					width = "full",
				},
				{
					type = "header",
					name = AUI.L10n.GetString("outgoing"),
				},			
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_dps"),
					getFunc = function() return AUI.Settings.Combat.minimeter_show_dps_out end,
					setFunc = function(value)
						AUI.Settings.Combat.minimeter_show_dps_out = value
						AUI.Combat.Minimeter.UpdateUI()
					end,
					default = GetDefaultSettings().minimeter_show_dps_out,
					width = "full",
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_total_damage"),
					getFunc = function() return AUI.Settings.Combat.minimeter_show_total_damage_out end,
					setFunc = function(value)
						AUI.Settings.Combat.minimeter_show_total_damage_out = value
						AUI.Combat.Minimeter.UpdateUI()
					end,
					default = GetDefaultSettings().minimeter_show_total_damage_out,
					width = "full",
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_hps"),
					getFunc = function() return AUI.Settings.Combat.minimeter_show_hps_out end,
					setFunc = function(value)
						AUI.Settings.Combat.minimeter_show_hps_out = value
						AUI.Combat.Minimeter.UpdateUI()
					end,
					default = GetDefaultSettings().minimeter_show_hps_out,
					width = "full",
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_total_heal"),
					getFunc = function() return AUI.Settings.Combat.minimeter_show_total_heal_out end,
					setFunc = function(value)
						AUI.Settings.Combat.minimeter_show_total_heal_out = value
						AUI.Combat.Minimeter.UpdateUI()
					end,
					default = GetDefaultSettings().minimeter_show_total_heal_out,
					width = "full",
				},	
				{
					type = "header",
					name = AUI.L10n.GetString("incoming"),
				},		
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_dps"),
					getFunc = function() return AUI.Settings.Combat.minimeter_show_dps_in end,
					setFunc = function(value)
						AUI.Settings.Combat.minimeter_show_dps_in = value
						AUI.Combat.Minimeter.UpdateUI()
					end,
					default = GetDefaultSettings().minimeter_show_dps_in,
					width = "full",
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_total_damage"),
					getFunc = function() return AUI.Settings.Combat.minimeter_show_total_damage_in end,
					setFunc = function(value)
						AUI.Settings.Combat.minimeter_show_total_damage_in = value
						AUI.Combat.Minimeter.UpdateUI()
					end,
					default = GetDefaultSettings().minimeter_show_total_damage_in,
					width = "full",
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_hps"),
					getFunc = function() return AUI.Settings.Combat.minimeter_show_hps_in end,
					setFunc = function(value)
						AUI.Settings.Combat.minimeter_show_hps_in = value
						AUI.Combat.Minimeter.UpdateUI()
					end,
					default = GetDefaultSettings().minimeter_show_hps_in,
					width = "full",
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_total_heal"),
					getFunc = function() return AUI.Settings.Combat.minimeter_show_total_heal_in end,
					setFunc = function(value)
						AUI.Settings.Combat.minimeter_show_total_heal_in = value
						AUI.Combat.Minimeter.UpdateUI()
					end,
					default = GetDefaultSettings().minimeter_show_total_heal_in,
					width = "full",
				},		
				{
					type = "header",
				},			
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_combat_time"),
					getFunc = function() return AUI.Settings.Combat.minimeter_show_combat_time end,
					setFunc = function(value)
						AUI.Settings.Combat.minimeter_show_combat_time = value
						AUI.Combat.Minimeter.UpdateUI()
					end,
					default = GetDefaultSettings().minimeter_show_combat_time,
					width = "full",
				},	
				{
					type = "button",
					name = AUI.L10n.GetString("reset_to_default_position"),
					tooltip = AUI.L10n.GetString("reset_to_default_position_tooltip"),
					func = function() AUI.Combat.Minimeter.SetToDefaultPosition(GetDefaultSettings()) end,
				},					
			}
		},
	}
	
	return optionsTable
end

local function GetScrollingTextOptions()
	local optionsTable = {	
		{
			type = "header",
			name = AUI_TXT_COLOR_HEADER:Colorize(AUI.L10n.GetString("scrolling_text")),
		},		
		{		
			type = "submenu",
			name = AUI_TXT_COLOR_SUBMENU:Colorize(AUI.L10n.GetString("outgoing")),
			controls = 
			{	
				{
					type = "header",
					name = AUI.L10n.GetString("general"),
				},							
				{
					type = "slider",
					name = AUI.L10n.GetString("width"),
					tooltip = AUI.L10n.GetString("width_tooltip"),
					min = 200,
					max = 1000,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_out_main_window_width end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_out_main_window_width = value
						AUI.Combat.Text.UpdateUI()
					  end,
					default = GetDefaultSettings().scrolling_text_out_main_window_width,
					width = "half",
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("height"),
					tooltip = AUI.L10n.GetString("height_tooltip"),
					min = 200,
					max = 1000,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_out_main_window_height end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_out_main_window_height = value
						AUI.Combat.Text.UpdateUI()
					  end,
					default = GetDefaultSettings().scrolling_text_out_main_window_height,
					width = "half",
				},									
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_icons"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_out_show_icons end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_out_show_icons = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_out_show_icons,
					width = "full",
				},						
				{
					type = "dropdown",
					name = AUI.L10n.GetString("animation_art"),
					tooltip = AUI.L10n.GetString("animation_art_tooltip"),
					choices = AUI.Table.GetChoiceList(AUI.Menu.GetTextAnimationList(), "value"),
					getFunc = function() return AUI.Table.GetValue(AUI.Menu.GetTextAnimationList(), AUI.Settings.Combat.scrolling_text_out_animation) end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_out_animation = AUI.Table.GetKey(AUI.Menu.GetTextAnimationList(), value)
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_out_animation,		
				},
				{
					type = "dropdown",
					name = AUI.L10n.GetString("animation_mode"),
					tooltip = AUI.L10n.GetString("animation_mode_tooltip"),
					choices = AUI.Table.GetChoiceList(AUI.Menu.GetTextAnimationTypeList(), "value"),
					getFunc = function() return AUI.Table.GetValue(AUI.Menu.GetTextAnimationTypeList(), AUI.Settings.Combat.scrolling_text_out_animation_mode) end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_out_animation_mode = AUI.Table.GetKey(AUI.Menu.GetTextAnimationTypeList(), value)
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)	
					end,
					default = GetDefaultSettings().scrolling_text_out_animation_mode,		
				},
				{
					type = "slider",
					name = AUI.L10n.GetString("animation_duration"),
					tooltip = AUI.L10n.GetString("animation_duration_tooltip"),
					min = 1,
					max = 5,
					step = 0.0625,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_out_duration end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_out_duration = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_out_duration,
					width = "full",
				},		
				{
					type = "button",
					name = AUI.L10n.GetString("reset_to_default_position"),
					tooltip = AUI.L10n.GetString("reset_to_default_position_tooltip"),
					func = function() AUI.Combat.Text.SetOutgoingPanelToDefaultPosition(GetDefaultSettings()) end,
				},				
				{
					type = "header",
					name = AUI.L10n.GetString("damage"),
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_damage_out end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_damage_out = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_damage_out,
					width = "full",
				},				
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_out_damage_normal_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_out_damage_normal_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_out_damage_normal_size,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_damage_out_normal_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_damage_out_normal_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)				
					end,
					default = GetDefaultSettings().scrolling_text_damage_out_normal_font_art,		
				},					
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_damage_out_normal end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_damage_out_normal = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_damage_out_normal,
					width = "full",
				},					
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_damage_out_color_normal):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_damage_out_color_normal = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_damage_out_color_normal,
					width = "full",
				},	
				{
					type = "header",
					name = AUI.L10n.GetString("critical_damage"),
				},
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_critical_damage_out end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_critical_damage_out = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_critical_damage_out,
					width = "full",
				},					
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_out_damage_crit_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_out_damage_crit_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_out_damage_crit_size,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_damage_out_crit_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_damage_out_crit_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)			
					end,
					default = GetDefaultSettings().scrolling_text_damage_out_crit_font_art,		
				},					
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_damage_out_crit end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_damage_out_crit = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_damage_out_crit,
					width = "full",
				},					
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_damage_out_color_crit):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_damage_out_color_crit = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_damage_out_color_crit,
					width = "full",
				},	
				{
					type = "header",
					name = AUI.L10n.GetString("healing"),
				},
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_heal_out end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_heal_out = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_heal_out,
					width = "full",
				},					
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_out_heal_normal_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_out_heal_normal_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_out_heal_normal_size,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_heal_out_normal_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_heal_out_normal_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)		
					end,
					default = GetDefaultSettings().scrolling_text_heal_out_normal_font_art,		
				},				
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_heal_out_normal end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_heal_out_normal = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_heal_out_normal,
					width = "full",
				},					
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_heal_out_color_normal):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_heal_out_color_normal = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_heal_out_color_normal,
					width = "full",
				},	
				{
					type = "header",
					name = AUI.L10n.GetString("critical_healing"),
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_critical_heal_out end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_critical_heal_out = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_critical_heal_out,
					width = "full",
				},					
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_out_heal_crit_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_out_heal_crit_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_out_heal_crit_size,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_heal_out_crit_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_heal_out_crit_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)				
					end,
					default = GetDefaultSettings().scrolling_text_heal_out_crit_font_art,		
				},					
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_heal_out_crit end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_heal_out_crit = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_heal_out_crit,
					width = "full",
				},					
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_heal_out_color_crit):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_heal_out_color_crit = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_OutgoingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_heal_out_color_crit,
					width = "full",
				},						
			}
		},
		{
			type = "submenu",
			name = AUI_TXT_COLOR_SUBMENU:Colorize(AUI.L10n.GetString("incoming")),
			controls = 
			{
				{
					type = "header",
					name = AUI.L10n.GetString("general")
				},								
				{					
					type = "slider",
					name = AUI.L10n.GetString("width"),
					tooltip = AUI.L10n.GetString("width_tooltip"),
					min = 200,
					max = 1000,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_in_main_window_width end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_in_main_window_width = value
						AUI.Combat.Text.UpdateUI()
					  end,
					default = GetDefaultSettings().scrolling_text_in_main_window_width,
					width = "half",
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("height"),
					tooltip = AUI.L10n.GetString("height_tooltip"),
					min = 200,
					max = 1000,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_in_main_window_height end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_in_main_window_height = value
						AUI.Combat.Text.UpdateUI()
					  end,
					default = GetDefaultSettings().scrolling_text_in_main_window_height,
					width = "half",
				},								
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_icons"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_in_show_icons end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_in_show_icons = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_in_show_icons,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("animation_art"),
					tooltip = AUI.L10n.GetString("animation_tooltip"),
					choices = AUI.Table.GetChoiceList(AUI.Menu.GetTextAnimationList(), "value"),
					getFunc = function() return AUI.Table.GetValue(AUI.Menu.GetTextAnimationList(), AUI.Settings.Combat.scrolling_text_in_animation) end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_in_animation = AUI.Table.GetKey(AUI.Menu.GetTextAnimationList(), value)
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_in_animation,		
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("animation_mode"),
					tooltip = AUI.L10n.GetString("animation_mode_tooltip"),
					choices = AUI.Table.GetChoiceList(AUI.Menu.GetTextAnimationTypeList(), "value"),
					getFunc = function() return AUI.Table.GetValue(AUI.Menu.GetTextAnimationTypeList(), AUI.Settings.Combat.scrolling_text_in_animation_mode) end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_in_animation_mode = AUI.Table.GetKey(AUI.Menu.GetTextAnimationTypeList(), value)
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_in_animation_mode,		
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("animation_duration"),
					tooltip = AUI.L10n.GetString("animation_duration_tooltip"),
					min = 1,
					max = 5,
					step = 0.0625,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_in_duration end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_in_duration = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_in_duration,
					width = "full",
				},
				{
					type = "button",
					name =AUI.L10n.GetString("reset_to_default_position"),
					tooltip = AUI.L10n.GetString("reset_to_default_position_tooltip"),
					func = function() AUI.Combat.Text.SetIncomingPanelToDefaultPosition(GetDefaultSettings()) end,
				},				
				{
					type = "header",
					name = AUI.L10n.GetString("damage"),
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_damage_in end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_damage_in = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_damage_in,
					width = "full",
				},							
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_in_damage_normal_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_in_damage_normal_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_in_damage_normal_size,
					width = "full",
				},
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_damage_in_normal_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_damage_in_normal_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)				
					end,
					default = GetDefaultSettings().scrolling_text_damage_in_normal_font_art,		
				},					
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_damage_in_normal end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_damage_in_normal = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_damage_in_normal,
					width = "full",
				},					
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_damage_in_color_normal):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_damage_in_color_normal = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_damage_in_color_normal,
					width = "full",
				},	
				{
					type = "header",
					name = AUI.L10n.GetString("critical_damage"),
				},
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_critical_damage_in end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_critical_damage_in = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_critical_damage_in,
					width = "full",
				},									
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_in_damage_crit_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_in_damage_crit_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_in_damage_crit_size,
					width = "full",
				},
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_damage_in_crit_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_damage_in_crit_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)				
					end,
					default = GetDefaultSettings().scrolling_text_damage_in_crit_font_art,		
				},					
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_damage_in_crit end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_damage_in_crit = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_damage_in_crit,
					width = "full",
				},				
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_damage_in_color_crit):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_damage_in_color_crit = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_damage_in_color_crit,
					width = "full",
				},	
				{
					type = "header",
					name = AUI.L10n.GetString("healing"),
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_heal_in end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_heal_in = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_heal_in,
					width = "full",
				},					
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_in_heal_normal_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_in_heal_normal_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_in_heal_normal_size,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_heal_in_normal_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_heal_in_normal_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)				
					end,
					default = GetDefaultSettings().scrolling_text_heal_in_normal_font_art,		
				},					
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_heal_in_normal end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_heal_in_normal = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_heal_in_normal,
					width = "full",
				},				
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_heal_in_color_normal):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_heal_in_color_normal = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_heal_in_color_normal,
					width = "full",
				},	
				{
					type = "header",
					name = AUI.L10n.GetString("critical_healing"),
				},
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_critical_heal_in end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_critical_heal_in = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_critical_heal_in,
					width = "full",
				},				
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_in_heal_crit_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_in_heal_crit_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_in_heal_crit_size,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_heal_in_crit_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_heal_in_crit_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)		
					end,
					default = GetDefaultSettings().scrolling_text_heal_in_crit_font_art,		
				},					
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_heal_in_crit end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_heal_in_crit = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_heal_in_crit,
					width = "full",
				},						
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_heal_in_color_crit):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_heal_in_color_crit = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_IncomingPanel)
					end,
					default = GetDefaultSettings().scrolling_text_heal_in_color_crit,
					width = "full",
				},				
			}
		},
		{
			type = "submenu",
			name = AUI_TXT_COLOR_SUBMENU:Colorize(AUI.L10n.GetString("events")),
			controls = 
			{
				{
					type = "header",
					name = AUI.L10n.GetString("general"),
				},					
				{
					type = "slider",
					name = AUI.L10n.GetString("width"),
					tooltip = AUI.L10n.GetString("width_tooltip"),
					min = 200,
					max = 1000,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_report_main_window_width end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_report_main_window_width = value
						AUI.Combat.Text.UpdateUI()
					  end,
					default = GetDefaultSettings().scrolling_text_report_main_window_width,
					width = "half",
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("height"),
					tooltip = AUI.L10n.GetString("height_tooltip"),
					min = 200,
					max = 1000,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_report_main_window_height end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_report_main_window_height = value
						AUI.Combat.Text.UpdateUI()
					  end,
					default = GetDefaultSettings().scrolling_text_report_main_window_height,
					width = "half",
				},				
				{
					type = "dropdown",
					name = AUI.L10n.GetString("animation_art"),
					tooltip = AUI.L10n.GetString("animation_tooltip"),
					choices = AUI.Table.GetChoiceList(AUI.Menu.GetTextAnimationList(), "value"),
					getFunc = function() return AUI.Table.GetValue(AUI.Menu.GetTextAnimationList(), AUI.Settings.Combat.scrolling_text_report_animation) end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_report_animation = AUI.Table.GetKey(AUI.Menu.GetTextAnimationList(), value)
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_report_animation,		
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("animation_mode"),
					tooltip = AUI.L10n.GetString("animation_mode_tooltip"),
					choices = AUI.Table.GetChoiceList(AUI.Menu.GetTextAnimationTypeList(), "value"),
					getFunc = function() return AUI.Table.GetValue(AUI.Menu.GetTextAnimationTypeList(), AUI.Settings.Combat.scrolling_text_report_animation_mode) end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_report_animation_mode = AUI.Table.GetKey(AUI.Menu.GetTextAnimationTypeList(), value)
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_report_animation_mode,		
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("animation_duration"),
					tooltip = AUI.L10n.GetString("animation_duration_tooltip"),
					min = 1,
					max = 5,
					step = 0.0625,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_report_duration end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_report_duration = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_report_duration,
					width = "full",
				},				
				{
					type = "button",
					name = AUI.L10n.GetString("reset_to_default_position"),
					tooltip = AUI.L10n.GetString("reset_to_default_position_tooltip"),
					func = function() AUI.Combat.Text.SetReportPanelToDefaultPosition(GetDefaultSettings()) end,
				},				
				{
					type = "header",
					name = AUI.L10n.GetString("experience"),
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_exp end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_exp = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_exp,
					width = "full",
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_exp_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_exp_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_exp_size,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_exp_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_exp_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)				
					end,
					default = GetDefaultSettings().scrolling_text_exp_font_art,		
				},				
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_exp end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_exp = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_exp,
					width = "full",
				},				
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_exp_color):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_exp_color = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_exp_color,
					width = "full",
				},
				{
					type = "header",
					name = AUI.L10n.GetString("champion_experience"),
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_cxp end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_cxp = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_cxp,
					width = "full",
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_cxp_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_cxp_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_cxp_size,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_cxp_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_cxp_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)				
					end,
					default = GetDefaultSettings().scrolling_text_cxp_font_art,		
				},					
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_cxp end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_cxp = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_cxp,
					width = "full",
				},				
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_cxp_color):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_cxp_color = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_cxp_color,
					width = "full",
				},				
				{
					type = "header",
					name = AUI.L10n.GetString("telvar"),
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_telvar end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_telvar = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_telvar,
					width = "full",
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_telvar_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_telvar_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_telvar_size,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_telvar_fontart end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_telvar_fontart = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)				
					end,
					default = GetDefaultSettings().scrolling_text_telvar_fontart,		
				},					
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_telvar end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_telvar = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_telvar,
					width = "full",
				},					
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_telvar_color):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_telvar_color = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_telvar_color,
					width = "full",
				},
				{
					type = "header",
					name = AUI.L10n.GetString("alliance_points"),
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_ap end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_ap = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_ap,
					width = "full",
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_ap_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_ap_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_ap_size,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_ap_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_ap_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)				
					end,
					default = GetDefaultSettings().scrolling_text_ap_font_art,		
				},					
				{
					type = "checkbox",
					name = AUI.L10n.GetString("assembling_value"),
					tooltip = AUI.L10n.GetString("assembling_value_tooltip"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_assemble_ap end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_assemble_ap = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_assemble_ap,
					width = "full",
				},					
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_ap_color):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_ap_color = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_ap_color,
					width = "full",
				},				
				{
					type = "header",
					name =AUI.L10n.GetString("combat_start"),
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_combat_start end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_combat_start = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_combat_start,
					width = "full",
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_combat_start_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_combat_start_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_combat_start_size,
					width = "full",
				},
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_combat_start_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_combat_start_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)				
					end,
					default = GetDefaultSettings().scrolling_text_combat_start_font_art,		
				},				
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_combat_start_color):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_combat_start_color = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_combat_start_color,
					width = "full",
				},				
				{
					type = "header",
					name = AUI.L10n.GetString("combat_end"),
				},
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_combat_end end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_combat_end = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_combat_end,
					width = "full",
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_combat_end_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_combat_end_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_combat_end_size,
					width = "full",
				},
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_combat_end_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_combat_end_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)			
					end,
					default = GetDefaultSettings().scrolling_text_combat_end_font_art,		
				},				
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_combat_end_color):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_combat_end_color = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_combat_end_color,
					width = "full",
				},
				{
					type = "header",
					name = AUI.L10n.GetString("ability_procs"),
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_instant_casts end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_instant_casts = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_instant_casts,
					width = "full",
				},
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_instant_cast_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_instant_cast_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_instant_cast_size,
					width = "full",
				},	
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_instant_cast_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_instant_cast_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)					
					end,
					default = GetDefaultSettings().scrolling_text_instant_cast_font_art,		
				},					
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_instant_cast_color):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_instant_cast_color = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_instant_cast_color,
					width = "full",
				},	
				{
					type = "header",
					name = AUI.L10n.GetString("ultimate"),
				},
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_ultimate_ready end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_ultimate_ready = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_ultimate_ready,
					width = "full",
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_ultimate_ready_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_ultimate_ready_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_ultimate_ready_size,
					width = "full",
				},		
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_ultimate_ready_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_ultimate_ready_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)					
					end,
					default = GetDefaultSettings().scrolling_text_ultimate_ready_font_art,		
				},					
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_ultimate_ready_color):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_ultimate_ready_color = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_ultimate_ready_color,
					width = "full",
				},					
				{
					type = "header",
					name = AUI.L10n.GetString("potions"),
				},	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show"),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_show_potion_ready end,
					setFunc = function(value)
						AUI.Settings.Combat.scrolling_text_show_potion_ready = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_show_potion_ready,
					width = "full",
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 18,
					max = 40,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.scrolling_text_potion_ready_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.scrolling_text_potion_ready_size = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					  end,
					default = GetDefaultSettings().scrolling_text_potion_ready_size,
					width = "full",
				},		
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.scrolling_text_potion_ready_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.scrolling_text_potion_ready_font_art = value
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)					
					end,
					default = GetDefaultSettings().scrolling_text_potion_ready_font_art,		
				},					
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.scrolling_text_potion_ready_color):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.scrolling_text_potion_ready_color = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.Text.UpdatePreview(AUI_Scrolling_Text_ReportPanel)
					end,
					default = GetDefaultSettings().scrolling_text_potion_ready_color,
					width = "full",
				},				
			}
		},
	}
	return optionsTable
end

local function GetDamageMeterOptions()
	local optionsTable = {	
		{		
			type = "submenu",
			name = AUI_TXT_COLOR_SUBMENU:Colorize(AUI.L10n.GetString("damage_meter")),
			controls = 
			{		
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_background"),
					getFunc = function() return AUI.Settings.Combat.damage_meter_show_background end,
					setFunc = function(value)
						AUI.Settings.Combat.damage_meter_show_background = value
						AUI.Combat.DamageMeter.UpdatePreview()
					end,
					default = GetDefaultSettings().damage_meter_show_background,
					width = "full",
				},
				{
					type = "checkbox",
					name = AUI.L10n.GetString("show_only_in_group"),
					getFunc = function() return AUI.Settings.Combat.damage_meter_show_only_in_group end,
					setFunc = function(value)
						AUI.Settings.Combat.damage_meter_show_only_in_group = value
						AUI.Combat.DamageMeter.UpdatePreview()
					end,
					default = GetDefaultSettings().damage_meter_show_only_in_group,
					width = "full",
				},				
				{
					type = "dropdown",
					name = AUI.L10n.GetString("font_art"),
					tooltip = AUI.L10n.GetString("font_art_tooltip"),
					choices = LMP:List(LMP.MediaType.FONT),
					getFunc = function() return AUI.Settings.Combat.damage_meter_font_art end,
					setFunc = function(value) 		
						AUI.Settings.Combat.damage_meter_font_art = value
						AUI.Combat.DamageMeter.UpdatePreview()			
					end,
					default = GetDefaultSettings().damage_meter_font_art,		
				},	
				{
					type = "slider",
					name = AUI.L10n.GetString("size"),
					tooltip = AUI.L10n.GetString("size_tooltip"),
					min = 8,
					max = 16,
					step = 1,
					getFunc = function() return AUI.Settings.Combat.damage_meter_font_size end,
					setFunc = function(value) 
						AUI.Settings.Combat.damage_meter_font_size = value
						AUI.Combat.DamageMeter.UpdatePreview()
					  end,
					default = GetDefaultSettings().damage_meter_font_size,
					width = "full",
				},	
				{
					type = "colorpicker",
					name = AUI.L10n.GetString("font_color"),
					getFunc = function() return AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Combat.damage_meter_font_color):UnpackRGBA() end,
					setFunc = function(r,g,b,a) 
						AUI.Settings.Combat.damage_meter_font_color = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}	
						AUI.Combat.DamageMeter.UpdatePreview()
					end,
					default = GetDefaultSettings().damage_meter_font_color,
					width = "full",
				},				
				{
					type = "header",
				},				
				{
					type = "button",
					name = AUI.L10n.GetString("reset_to_default_position"),
					tooltip = AUI.L10n.GetString("reset_to_default_position_tooltip"),
					func = function() AUI.Combat.DamageMeter.SetToDefaultPosition(GetDefaultSettings()) end,
				},					
			}
		},
	}

	return optionsTable
end

local function CreateOptionTable()
	local optionsTable = {	
		{
			type = "header",
			name = AUI_TXT_COLOR_HEADER:Colorize(AUI.L10n.GetString("general"))
		},
		{
			type = "checkbox",
			name = AUI.L10n.GetString("acount_wide"),
			tooltip = AUI.L10n.GetString("acount_wide_tooltip"),
			getFunc = function() return AUI.MainSettings.modul_combat_account_wide end,
			setFunc = function(value)
						AUI.MainSettings.modul_combat_account_wide = value
						ReloadUI()
			end,
			default = true,
			width = "full",
			warning = AUI.L10n.GetString("reloadui_warning_tooltip"),
		},			
		{
			type = "checkbox",
			name = AUI.L10n.GetString("preview"),
			tooltip = AUI.L10n.GetString("preview_tooltip"),
			getFunc = function() return AUI.Combat.Minimeter.IsShow() end,
			setFunc = function(value)
						if value then
							AUI.Combat.Minimeter.ShowPreview()
							AUI.Combat.Text.ShowPreview()
							AUI.Combat.DamageMeter.ShowPreview()
						else
							AUI.Combat.Minimeter.HidePreview()
							AUI.Combat.Text.HidePreview()
							AUI.Combat.DamageMeter.HidePreview()
						end
			end,
			default = false,
			width = "full",
			warning = AUI.L10n.GetString("preview_warning"),	
		},		
		{		
			type = "submenu",
			name = AUI_TXT_COLOR_SUBMENU:Colorize(AUI.L10n.GetString("display_elements")),
			controls = 
			{	
				{
					type = "checkbox",
					name = AUI.L10n.GetString("activate_minimeter"),
					getFunc = function() return minimeter_enabled end,
					setFunc = function(value)
						minimeter_enabled = value
						changed = true
					end,
					default = GetDefaultSettings().minimeter_enabled,
					width = "full",
					warning = AUI.L10n.GetString("reloadui_manual_warning_tooltip"),			
				},
				{
					type = "checkbox",
					name = AUI.L10n.GetString("activate_scrolling_text"),
					getFunc = function() return scrolling_text_enabled end,
					setFunc = function(value)
						scrolling_text_enabled = value
						changed = true
					end,
					default = GetDefaultSettings().scrolling_text_enabled,
					width = "full",
					warning = AUI.L10n.GetString("reloadui_manual_warning_tooltip"),		
				},
				{
					type = "checkbox",
					name = AUI.L10n.GetString("activate_damage_meter") .." (" .. AUI.L10n.GetString("currently_not_supported") .. ")",
					getFunc = function() return damage_meter_enabled end,
					setFunc = function(value)
						damage_meter_enabled = value
						changed = true
					end,
					default = GetDefaultSettings().damage_meter_enabled,
					width = "full",
					warning = AUI.L10n.GetString("reloadui_manual_warning_tooltip"),
					disabled = true,
				},				
				{
					type = "button",
					name = AUI.L10n.GetString("accept_settings"),
					func = function() AcceptSettings() end,
					disabled = function() return not changed end,
				},			
			}
		},		
	}

	if minimeter_enabled then
		local minimeterOptions = GetMinimeterOptions()
		for i = 1 , #minimeterOptions do 
			table.insert(optionsTable, minimeterOptions[i]) 
		end		
	end		
	
	if damage_meter_enabled then
		local damageMeterTextOptions = GetDamageMeterOptions()
		for i = 1 , #damageMeterTextOptions do 
			table.insert(optionsTable, damageMeterTextOptions[i]) 
		end		
	end		
	
	if scrolling_text_enabled then
		local scrollingTextOptions = GetScrollingTextOptions()
		for i = 1 , #scrollingTextOptions do 
			table.insert(optionsTable, scrollingTextOptions[i]) 
		end		
	end	
	
	LAM:RegisterOptionControls("AUI_Menu_Combat", optionsTable)
end

local function LoadSettings()
	if AUI.MainSettings.modul_combat_account_wide then
		AUI.Settings.Combat = ZO_SavedVars:NewAccountWide("AUI_Combat", 4, nil, GetDefaultSettings())
	else
		AUI.Settings.Combat = ZO_SavedVars:New("AUI_Combat", 4, nil, GetDefaultSettings())
	end		
	
	minimeter_enabled = AUI.Settings.Combat.minimeter_enabled
	scrolling_text_enabled = AUI.Settings.Combat.scrolling_text_enabled
	damage_meter_enabled = AUI.Settings.Combat.damage_meter_enabled
end

function AUI.Combat.SetMenuData()
	if isLoaded then
		return
	end

	local panelData = {
		type = "panel",
		name = AUI_MAIN_NAME .. " (" ..  AUI.L10n.GetString("combat_module_name") .. ")",
		displayName = "|cFFFFB0" .. AUI_MAIN_NAME .. " (" .. AUI.L10n.GetString("combat_module_name") .. ")",
		author = AUI_TXT_COLOR_AUTHOR:Colorize(AUI_COMBAT_AUTHOR),
		version = AUI_TXT_COLOR_VERSION:Colorize(AUI_COMBAT_VERSION),
		slashCommand = "/auicombat",
		registerForRefresh = true,
		registerForDefaults = true,
	}
	
	LoadSettings()
	CreateOptionTable()
	
	AUI.Settings.Combat.damage_meter_enabled = false
	
	LAM:RegisterAddonPanel("AUI_Menu_Combat", panelData)
	
	isLoaded = true
end
